#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two3004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two3004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two3004xi
#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 300
# -------------------------------------------------------------------------------------------------
shot2two3004xi = {
        1:'0x0y-299z',
        2:'101x-138y-246z',
        3:'102x-280y-27z',
        4:'107x-130y-247z',
        5:'10x-299y-9z',
        6:'112x-123y-249z',
        7:'116x-115y-251z',
        8:'116x-274y-30z',
        9:'11x-127y-271z',
        10:'11x-197y-225z',
        11:'120x-107y-252z',
        12:'124x-99y-254z',
        13:'126x-91y-256z',
        14:'127x-5y-271z',
        15:'129x-12y-270z',
        16:'129x-82y-257z',
        17:'12x-159y-253z',
        18:'130x-267y-33z',
        19:'131x-19y-269z',
        20:'131x-74y-259z',
        21:'132x-27y-267z',
        22:'132x-66y-260z',
        23:'133x-34y-266z',
        24:'133x-58y-262z',
        25:'134x-42y-264z',
        26:'134x-50y-263z',
        27:'140x-264y0z',
        28:'144x-260y-36z',
        29:'154x-257y-2z',
        30:'157x-252y-39z',
        31:'167x-248y-5z',
        32:'170x-243y-42z',
        33:'180x-239y-8z',
        34:'182x-233y-45z',
        35:'18x-123y-272z',
        36:'192x-229y-11z',
        37:'194x-223y-48z',
        38:'1x-199y-223z',
        39:'204x-219y-14z',
        40:'205x-212y-51z',
        41:'20x-155y-255z',
        42:'215x-201y-54z',
        43:'215x-208y-17z',
        44:'21x-193y-227z',
        45:'225x-189y-56z',
        46:'225x-196y-20z',
        47:'234x-176y-59z',
        48:'235x-184y-23z',
        49:'243x-163y-62z',
        50:'244x-171y-26z',
        51:'24x-119y-273z',
        52:'250x-150y-65z',
        53:'253x-158y-29z',
        54:'257x-136y-68z',
        55:'260x-144y-32z',
        56:'264x-122y-71z',
        57:'267x-130y-35z',
        58:'269x-108y-74z',
        59:'26x-298y-12z',
        60:'273x-116y-38z',
        61:'274x-94y-77z',
        62:'277x-79y-80z',
        63:'279x-101y-41z',
        64:'27x-152y-257z',
        65:'280x-64y-83z',
        66:'283x-49y-86z',
        67:'283x-86y-44z',
        68:'284x-19y-91z',
        69:'284x-34y-88z',
        70:'284x-4y-94z',
        71:'287x-71y-47z',
        72:'289x-77y0z',
        73:'290x-56y-50z',
        74:'292x-41y-53z',
        75:'293x-10y-59z',
        76:'293x-25y-56z',
        77:'293x-62y-3z',
        78:'296x-46y-6z',
        79:'298x-31y-9z',
        80:'299x-15y-12z',
        81:'29x-115y-275z',
        82:'31x-190y-229z',
        83:'34x-111y-276z',
        84:'35x-147y-258z',
        85:'3x-162y-252z',
        86:'40x-186y-231z',
        87:'41x-296y-15z',
        88:'42x-143y-260z',
        89:'48x-138y-261z',
        90:'49x-181y-233z',
        91:'52x-142y-370z',
        92:'54x-133y-263z',
        93:'57x-293y-18z',
        94:'58x-176y-235z',
        95:'5x-130y-270z',
        96:'60x-127y-264z',
        97:'65x-122y-265z',
        98:'66x-170y-237z',
        99:'70x-116y-267z',
        100:'72x-290y-21z',
        101:'74x-164y-239z',
        102:'75x-110y-268z',
        103:'79x-104y-269z',
        104:'82x-158y-240z',
        105:'82x-97y-271z',
        106:'83x-2y-288z',
        107:'85x-7y-287z',
        108:'86x-91y-272z',
        109:'87x-285y-24z',
        110:'88x-11y-286z',
        111:'88x-84y-273z',
        112:'89x-152y-242z',
        113:'90x-17y-285z',
        114:'91x-78y-274z',
        115:'92x-22y-284z',
        116:'92x-71y-276z',
        117:'93x-27y-283z',
        118:'94x-33y-282z',
        119:'94x-65y-277z',
        120:'95x-145y-244z',
        121:'95x-39y-281z',
        122:'95x-45y-280z',
        123:'95x-52y-279z',
        124:'95x-58y-278z'}
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire300two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire300two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE300TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE300TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE300TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE300TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE300TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two3004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE300TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE300TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE300TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two3004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two3004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE300TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE300TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE300TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two3004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        